# `@vivo-minigame/cli`

> 为开发者提供的初始化vivo小游戏的工具

安装 [@vivo-minigame/cli](https://www.npmjs.com/package/@vivo-minigame/cli) 后，便可使用 `mg` 命令。安装方法如下：

```bash
npm install -g @vivo-minigame/cli
```

## 使用

```
mg init <project-name> [-t <template>] [-c <cwd dir>] [-f]
```

## 参数

### `project-name`

要创建的小游戏工程的名称。可以为 `.` ，当 `project-name` 为`.`时表示在当前目录创建小游戏工程。

### `-t`

指定创建vivo小游戏工程使用的模板，默认为`default`，表示使用默认的模板。不指定该参数时就使用默认的模板。

> 目前只有`default`模板，所以该参数可以不指定，使用默认值即可

### `-c`

指定创建vivo小游戏工程的目录，不指定该参数时，使用`process.cwd()`也就是当前执行目录来创建，如果指定 了路径，就在指定路径创建。

### `-f`

如果指定的 `project-name` 目录已经存在，会提示用户是 '覆盖' 还是 '合并'，指定 -f 或者 --force 可以忽略提示，直接强制覆盖

## 示例


```
//在当前路径创建名为abc的小游戏工程
mg init abc

//在当前路径创建名为abc的小游戏工程，如果已经存在 abc 则强制覆盖
mg init abc -f

//在当前路径直接创建小游戏工程， 假设当前路径为`/usr/name/demoGame/`，那么小游戏工程名为demoGame          
mg init .             

// 在 `/usr/name/documents/`路径创建名为abc的小游戏工程
mg init abc -c /usr/name/documents/

// 在 `/usr/name/demoGame/`路径直接创建小游戏工程，即小游戏工程名为 demoGame
mg init . -c /usr/name/demoGame/
```

