import*as TextUtils from"../../models/text_utils/text_utils.js";import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as HttpReasonPhraseStrings from"./HttpReasonPhraseStrings.js";import{Attributes}from"./Cookie.js";import{CookieParser}from"./CookieParser.js";import{NetworkManager,Events as NetworkManagerEvents}from"./NetworkManager.js";import{Type}from"./Target.js";import{ServerTiming}from"./ServerTiming.js";const UIStrings={binary:"(binary)",secureOnly:'This cookie was blocked because it had the "`Secure`" attribute and the connection was not secure.',notOnPath:"This cookie was blocked because its path was not an exact match for or a superdirectory of the request url's path.",domainMismatch:"This cookie was blocked because neither did the request URL's domain exactly match the cookie's domain, nor was the request URL's domain a subdomain of the cookie's Domain attribute value.",sameSiteStrict:'This cookie was blocked because it had the "`SameSite=Strict`" attribute and the request was made from a different site. This includes top-level navigation requests initiated by other sites.',sameSiteLax:'This cookie was blocked because it had the "`SameSite=Lax`" attribute and the request was made from a different site and was not initiated by a top-level navigation.',sameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "`SameSite`" attribute when it was stored and was defaulted to "SameSite=Lax," and was blocked because the request was made from a different site and was not initiated by a top-level navigation. The cookie had to have been set with "`SameSite=None`" to enable cross-site usage.',sameSiteNoneInsecure:'This cookie was blocked because it had the "`SameSite=None`" attribute but was not marked "Secure". Cookies without SameSite restrictions must be marked "Secure" and sent over a secure connection.',userPreferences:"This cookie was blocked due to user preferences.",unknownError:"An unknown error was encountered when trying to send this cookie.",schemefulSameSiteStrict:'This cookie was blocked because it had the "`SameSite=Strict`" attribute but the request was cross-site. This includes top-level navigation requests initiated by other sites. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteLax:'This cookie was blocked because it had the "`SameSite=Lax`" attribute but the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "`SameSite`" attribute when it was stored, was defaulted to "`SameSite=Lax"`, and was blocked because the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',samePartyFromCrossPartyContext:"This cookie was blocked because it had the \"`SameParty`\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",nameValuePairExceedsMaxSize:"This cookie was blocked because it was too large. The combined size of the name and value must be less than or equal to 4096 characters.",thisSetcookieWasBlockedDueToUser:"This attempt to set a cookie via a `Set-Cookie` header was blocked due to user preferences.",thisSetcookieHadInvalidSyntax:"This `Set-Cookie` header had invalid syntax.",thisSetcookieHadADisallowedCharacter:"This `Set-Cookie` header contained a disallowed character (a forbidden ASCII control character, or the tab character if it appears in the middle of the cookie name, value, an attribute name, or an attribute value).",theSchemeOfThisConnectionIsNot:"The scheme of this connection is not allowed to store cookies.",anUnknownErrorWasEncounteredWhenTrying:"An unknown error was encountered when trying to store this cookie.",thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "{PH1}" attribute but came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieDidntSpecifyASamesite:'This `Set-Cookie` header didn\'t specify a "`SameSite`" attribute, was defaulted to "`SameSite=Lax"`, and was blocked because it came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieWasBlockedBecauseItHadTheSameparty:"This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the \"`SameParty`\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "`SameParty`" attribute but also had other conflicting attributes. Chrome requires cookies that use the "`SameParty`" attribute to also have the "Secure" attribute, and to not be restricted to "`SameSite=Strict`".',blockedReasonSecureOnly:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "Secure" attribute but was not received over a secure connection.',blockedReasonSameSiteStrictLax:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "{PH1}" attribute but came from a cross-site response which was not the response to a top-level navigation.',blockedReasonSameSiteUnspecifiedTreatedAsLax:'This `Set-Cookie` header didn\'t specify a "`SameSite`" attribute and was defaulted to "`SameSite=Lax,`" and was blocked because it came from a cross-site response which was not the response to a top-level navigation. The `Set-Cookie` had to have been set with "`SameSite=None`" to enable cross-site usage.',blockedReasonSameSiteNoneInsecure:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it had the "`SameSite=None`" attribute but did not have the "Secure" attribute, which is required in order to use "`SameSite=None`".',blockedReasonOverwriteSecure:"This attempt to set a cookie via a `Set-Cookie` header was blocked because it was not sent over a secure connection and would have overwritten a cookie with the Secure attribute.",blockedReasonInvalidDomain:"This attempt to set a cookie via a `Set-Cookie` header was blocked because its Domain attribute was invalid with regards to the current host url.",blockedReasonInvalidPrefix:'This attempt to set a cookie via a `Set-Cookie` header was blocked because it used the "`__Secure-`" or "`__Host-`" prefix in its name and broke the additional rules applied to cookies with these prefixes as defined in `https://tools.ietf.org/html/draft-west-cookie-prefixes-05`.',thisSetcookieWasBlockedBecauseTheNameValuePairExceedsMaxSize:"This attempt to set a cookie via a `Set-Cookie` header was blocked because the cookie was too large. The combined size of the name and value must be less than or equal to 4096 characters.",setcookieHeaderIsIgnoredIn:"Set-Cookie header is ignored in response from url: {PH1}. The combined size of the name and value must be less than or equal to 4096 characters."},str_=i18n.i18n.registerUIStrings("core/sdk/NetworkRequest.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export var MIME_TYPE;!function(e){e.HTML="text/html",e.XML="text/xml",e.PLAIN="text/plain",e.XHTML="application/xhtml+xml",e.SVG="image/svg+xml",e.CSS="text/css",e.XSL="text/xsl",e.VTT="text/vtt",e.PDF="application/pdf",e.EVENTSTREAM="text/event-stream"}(MIME_TYPE||(MIME_TYPE={}));export class NetworkRequest extends Common.ObjectWrapper.ObjectWrapper{#e;#t;#r;#s;#n;#a;#i;#o;#h;#l;#c;#d;#u;#m;#I;#S;#p;statusCode;#f;requestMethod;requestTime;protocol;alternateProtocolUsage;mixedContentType;#g;#k;#T;#R;#v;#b;#C;#P;#y;#x;#q;#w;#H;#U;#L;#E;#D;#A;#O;#N;#M;connectionId;connectionReused;hasNetworkData;#F;#B;#W;#V;#z;#K;#j;#$;#_;#G;localizedFailDescription;#Q;#X;#Y;#J;#Z;#ee;#te;#re;#se;#ne;#ae;#ie;#oe;#he;#le;#ce;#de;#ue;#me;#Ie;#Se;#pe;#fe;#ge;#ke;#Te;#Re;#ve;#be;#Ce;#Pe;#ye;#xe;#qe;#we=new Map;#He;constructor(e,t,r,s,n,a,i,o){super(),this.#e=e,this.#t=t,this.setUrl(r),this.#r=s,this.#s=n,this.#n=a,this.#a=i,this.#i=o,this.#o=null,this.#h=null,this.#l=null,this.#c=!1,this.#d=null,this.#u=-1,this.#m=-1,this.#I=-1,this.#S=void 0,this.#p=void 0,this.statusCode=0,this.#f="",this.requestMethod="",this.requestTime=0,this.protocol="",this.alternateProtocolUsage=void 0,this.mixedContentType="none",this.#g=null,this.#k=null,this.#T=null,this.#R=null,this.#v=null,this.#b=Common.ResourceType.resourceTypes.Other,this.#C=null,this.#P=[],this.#y=[],this.#x={},this.#q="",this.#w=[],this.#U=[],this.#L=[],this.#E={},this.#D="",this.#A="Unknown",this.#O=null,this.#N="unknown",this.#M=null,this.connectionId="0",this.connectionReused=!1,this.hasNetworkData=!1,this.#F=null,this.#B=Promise.resolve(null),this.#W=!1,this.#V=!1,this.#z=[],this.#K=[],this.#j=[],this.#G=!1,this.#$=null,this.#_=null,this.localizedFailDescription=null,this.#xe=null,this.#qe=!1,this.#He=!1}static create(e,t,r,s,n,a,i){return new NetworkRequest(e,e,t,r,s,n,a,i)}static createForWebSocket(e,t,r){return new NetworkRequest(e,e,t,Platform.DevToolsPath.EmptyUrlString,null,null,r||null)}static createWithoutBackendRequest(e,t,r,s){return new NetworkRequest(e,void 0,t,r,null,null,s)}identityCompare(e){const t=this.requestId(),r=e.requestId();return t>r?1:t<r?-1:0}requestId(){return this.#e}backendRequestId(){return this.#t}url(){return this.#Q}isBlobRequest(){return this.#Q.startsWith("blob:")}setUrl(e){this.#Q!==e&&(this.#Q=e,this.#se=new Common.ParsedURL.ParsedURL(e),this.#Ce=void 0,this.#Pe=void 0,this.#ne=void 0,this.#ae=void 0)}get documentURL(){return this.#r}get parsedURL(){return this.#se}get frameId(){return this.#s}get loaderId(){return this.#n}setRemoteAddress(e,t){this.#D=e+":"+t,this.dispatchEventToListeners(Events.RemoteAddressChanged,this)}remoteAddress(){return this.#D}remoteAddressSpace(){return this.#A}getResponseCacheStorageCacheName(){return this.#le}setResponseCacheStorageCacheName(e){this.#le=e}serviceWorkerResponseSource(){return this.#ce}setServiceWorkerResponseSource(e){this.#ce=e}setReferrerPolicy(e){this.#O=e}referrerPolicy(){return this.#O}securityState(){return this.#N}setSecurityState(e){this.#N=e}securityDetails(){return this.#M}securityOrigin(){return this.#se.securityOrigin()}setSecurityDetails(e){this.#M=e}get startTime(){return this.#m||-1}setIssueTime(e,t){this.#u=e,this.#de=t,this.#m=e}issueTime(){return this.#u}pseudoWallTime(e){return this.#de?this.#de-this.#u+e:e}get responseReceivedTime(){return this.#X||-1}set responseReceivedTime(e){this.#X=e}getResponseRetrievalTime(){return this.#ue}setResponseRetrievalTime(e){this.#ue=e}get endTime(){return this.#I||-1}set endTime(e){this.timing&&this.timing.requestTime?this.#I=Math.max(e,this.responseReceivedTime):(this.#I=e,this.#X>e&&(this.#X=e)),this.dispatchEventToListeners(Events.TimingChanged,this)}get duration(){return-1===this.#I||-1===this.#m?-1:this.#I-this.#m}get latency(){return-1===this.#X||-1===this.#m?-1:this.#X-this.#m}get resourceSize(){return this.#me||0}set resourceSize(e){this.#me=e}get transferSize(){return this.#Y||0}increaseTransferSize(e){this.#Y=(this.#Y||0)+e}setTransferSize(e){this.#Y=e}get finished(){return this.#J}set finished(e){this.#J!==e&&(this.#J=e,e&&this.dispatchEventToListeners(Events.FinishedLoading,this))}get failed(){return this.#Z}set failed(e){this.#Z=e}get canceled(){return this.#ee}set canceled(e){this.#ee=e}get preserved(){return this.#te}set preserved(e){this.#te=e}blockedReason(){return this.#S}setBlockedReason(e){this.#S=e}corsErrorStatus(){return this.#p}setCorsErrorStatus(e){this.#p=e}wasBlocked(){return Boolean(this.#S)}cached(){return(Boolean(this.#Ie)||Boolean(this.#Se))&&!this.#Y}cachedInMemory(){return Boolean(this.#Ie)&&!this.#Y}fromPrefetchCache(){return Boolean(this.#pe)}setFromMemoryCache(){this.#Ie=!0,this.#ge=void 0}get fromDiskCache(){return this.#Se}setFromDiskCache(){this.#Se=!0}setFromPrefetchCache(){this.#pe=!0}get fetchedViaServiceWorker(){return Boolean(this.#fe)}set fetchedViaServiceWorker(e){this.#fe=e}initiatedByServiceWorker(){const e=NetworkManager.forRequest(this);return!!e&&e.target().type()===Type.ServiceWorker}get timing(){return this.#ge}set timing(e){if(!e||this.#Ie)return;this.#m=e.requestTime;const t=e.requestTime+e.receiveHeadersEnd/1e3;((this.#X||-1)<0||this.#X>t)&&(this.#X=t),this.#m>this.#X&&(this.#X=this.#m),this.#ge=e,this.dispatchEventToListeners(Events.TimingChanged,this)}setConnectTimingFromExtraInfo(e){this.#m=e.requestTime,this.dispatchEventToListeners(Events.TimingChanged,this)}get mimeType(){return this.#re}set mimeType(e){this.#re=e}get displayName(){return this.#se.displayName}name(){return this.#ne||this.parseNameAndPathFromURL(),this.#ne}path(){return this.#ae||this.parseNameAndPathFromURL(),this.#ae}parseNameAndPathFromURL(){if(this.#se.isDataURL())this.#ne=this.#se.dataURLDisplayName(),this.#ae="";else if(this.#se.isBlobURL())this.#ne=this.#se.url,this.#ae="";else if(this.#se.isAboutBlank())this.#ne=this.#se.url,this.#ae="";else{this.#ae=this.#se.host+this.#se.folderPathComponents;const e=NetworkManager.forRequest(this),t=e?Common.ParsedURL.ParsedURL.fromString(e.target().inspectedURL()):null;this.#ae=Platform.StringUtilities.trimURL(this.#ae,t?t.host:""),this.#se.lastPathComponent||this.#se.queryParams?this.#ne=this.#se.lastPathComponent+(this.#se.queryParams?"?"+this.#se.queryParams:""):this.#se.folderPathComponents?(this.#ne=this.#se.folderPathComponents.substring(this.#se.folderPathComponents.lastIndexOf("/")+1)+"/",this.#ae=this.#ae.substring(0,this.#ae.lastIndexOf("/"))):(this.#ne=this.#se.host,this.#ae="")}}get folder(){let e=this.#se.path;const t=e.indexOf("?");-1!==t&&(e=e.substring(0,t));const r=e.lastIndexOf("/");return-1!==r?e.substring(0,r):""}get pathname(){return this.#se.path}resourceType(){return this.#b}setResourceType(e){this.#b=e}get domain(){return this.#se.host}get scheme(){return this.#se.scheme}get statusText(){return this.#f||(this.#f=HttpReasonPhraseStrings.getStatusText(this.statusCode)),this.#f}set statusText(e){this.#f=e}redirectSource(){return this.#o}setRedirectSource(e){this.#o=e}preflightRequest(){return this.#h}setPreflightRequest(e){this.#h=e}preflightInitiatorRequest(){return this.#l}setPreflightInitiatorRequest(e){this.#l=e}isPreflightRequest(){return null!==this.#a&&void 0!==this.#a&&"preflight"===this.#a.type}redirectDestination(){return this.#d}setRedirectDestination(e){this.#d=e}requestHeaders(){return this.#L}setRequestHeaders(e){this.#L=e,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeadersText(){return this.#ke}setRequestHeadersText(e){this.#ke=e,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeaderValue(e){return this.#E[e]||(this.#E[e]=this.computeHeaderValue(this.requestHeaders(),e)),this.#E[e]}requestFormData(){return this.#B||(this.#B=NetworkManager.requestPostData(this)),this.#B}setRequestFormData(e,t){this.#B=e&&null===t?null:Promise.resolve(t),this.#F=null}filteredProtocolName(){const e=this.protocol.toLowerCase();return"h2"===e?"http/2.0":e.replace(/^http\/2(\.0)?\+/,"http/2.0+")}requestHttpVersion(){const e=this.requestHeadersText();if(!e){const e=this.requestHeaderValue("version")||this.requestHeaderValue(":version");return e||this.filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/(HTTP\/\d+\.\d+)$/);return t?t[1]:"HTTP/0.9"}get responseHeaders(){return this.#Te||[]}set responseHeaders(e){this.#Te=e,this.#Re=void 0,this.#be=void 0,this.#ve=void 0,this.#x={},this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get originalResponseHeaders(){return this.#w}set originalResponseHeaders(e){this.#w=e,this.#H=void 0}get setCookieHeaders(){return this.#U}set setCookieHeaders(e){this.#U=e}get responseHeadersText(){return this.#q}set responseHeadersText(e){this.#q=e,this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get sortedResponseHeaders(){return void 0!==this.#Re?this.#Re:(this.#Re=this.responseHeaders.slice(),this.#Re.sort((function(e,t){return Platform.StringUtilities.compare(e.name.toLowerCase(),t.name.toLowerCase())||Platform.StringUtilities.compare(e.value,t.value)})))}get sortedOriginalResponseHeaders(){return void 0!==this.#H?this.#H:(this.#H=this.originalResponseHeaders.slice(),this.#H.sort((function(e,t){return Platform.StringUtilities.compare(e.name.toLowerCase(),t.name.toLowerCase())||Platform.StringUtilities.compare(e.value,t.value)})))}get overrideTypes(){const e=[];return this.hasOverriddenContent&&e.push("content"),this.hasOverriddenHeaders()&&e.push("headers"),e}get hasOverriddenContent(){return this.#He}set hasOverriddenContent(e){this.#He=e}hasOverriddenHeaders(){if(!this.#w.length)return!1;const e=this.sortedResponseHeaders,t=this.sortedOriginalResponseHeaders;if(t.length!==e.length)return!0;for(let r=0;r<e.length;r++){if(e[r].name.toLowerCase()!==t[r].name.toLowerCase())return!0;if(e[r].value!==t[r].value)return!0}return!1}responseHeaderValue(e){return e in this.#x||(this.#x[e]=this.computeHeaderValue(this.responseHeaders,e)),this.#x[e]}wasIntercepted(){return this.#qe}setWasIntercepted(e){this.#qe=e}get responseCookies(){if(!this.#ve)if(this.#ve=CookieParser.parseSetCookie(this.responseHeaderValue("Set-Cookie"),this.domain)||[],this.#$)for(const e of this.#ve)e.setPartitionKey(this.#$);else if(this.#_)for(const e of this.#ve)e.setPartitionKeyOpaque();return this.#ve}responseLastModified(){return this.responseHeaderValue("last-modified")}allCookiesIncludingBlockedOnes(){return[...this.includedRequestCookies(),...this.responseCookies,...this.blockedRequestCookies().map((e=>e.cookie)),...this.blockedResponseCookies().map((e=>e.cookie))].filter((e=>Boolean(e)))}get serverTimings(){return void 0===this.#be&&(this.#be=ServerTiming.parseHeaders(this.responseHeaders)),this.#be}queryString(){if(void 0!==this.#Ce)return this.#Ce;let e=null;const t=this.url(),r=t.indexOf("?");if(-1!==r){e=t.substring(r+1);const s=e.indexOf("#");-1!==s&&(e=e.substring(0,s))}return this.#Ce=e,this.#Ce}get queryParameters(){if(this.#Pe)return this.#Pe;const e=this.queryString();return e?(this.#Pe=this.parseParameters(e),this.#Pe):null}async parseFormParameters(){const e=this.requestContentType();if(!e)return null;if(e.match(/^application\/x-www-form-urlencoded\s*(;.*)?$/i)){const e=await this.requestFormData();return e?this.parseParameters(e):null}const t=e.match(/^multipart\/form-data\s*;\s*boundary\s*=\s*(\S+)\s*$/);if(!t)return null;const r=t[1];if(!r)return null;const s=await this.requestFormData();return s?this.parseMultipartFormDataParameters(s,r):null}formParameters(){return this.#F||(this.#F=this.parseFormParameters()),this.#F}responseHttpVersion(){const e=this.#q;if(!e){const e=this.responseHeaderValue("version")||this.responseHeaderValue(":version");return e||this.filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/^(HTTP\/\d+\.\d+)/);return t?t[1]:"HTTP/0.9"}parseParameters(e){return e.split("&").map((function(e){const t=e.indexOf("=");return-1===t?{name:e,value:""}:{name:e.substring(0,t),value:e.substring(t+1)}}))}parseMultipartFormDataParameters(e,t){const r=Platform.StringUtilities.escapeForRegExp(t),s=new RegExp('^\\r\\ncontent-disposition\\s*:\\s*form-data\\s*;\\s*name="([^"]*)"(?:\\s*;\\s*filename="([^"]*)")?(?:\\r\\ncontent-type\\s*:\\s*([^\\r\\n]*))?\\r\\n\\r\\n(.*)\\r\\n$',"is");return e.split(new RegExp(`--${r}(?:--s*$)?`,"g")).reduce((function(e,t){const[r,n,a,i,o]=t.match(s)||[];if(!r)return e;const h=a||i?i18nString(UIStrings.binary):o;return e.push({name:n,value:h}),e}),[])}computeHeaderValue(e,t){t=t.toLowerCase();const r=[];for(let s=0;s<e.length;++s)e[s].name.toLowerCase()===t&&r.push(e[s].value);if(r.length)return"set-cookie"===t?r.join("\n"):r.join(", ")}contentData(){return this.#C||(this.#ye?this.#C=this.#ye():this.#C=NetworkManager.requestContentData(this)),this.#C}setContentDataProvider(e){console.assert(!this.#C,"contentData can only be set once."),this.#ye=e}contentURL(){return this.#Q}contentType(){return this.#b}async requestContent(){const{content:e,error:t,encoded:r}=await this.contentData();return{content:e,error:t,isEncoded:r}}async searchInContent(e,t,r){if(!this.#ye)return NetworkManager.searchInRequest(this,e,t,r);const s=await this.contentData();let n=s.content;return n?(s.encoded&&(n=window.atob(n)),TextUtils.TextUtils.performSearchInContent(n,e,t,r)):[]}isHttpFamily(){return Boolean(this.url().match(/^https?:/i))}requestContentType(){return this.requestHeaderValue("Content-Type")}hasErrorStatusCode(){return this.statusCode>=400}setInitialPriority(e){this.#g=e}initialPriority(){return this.#g}setPriority(e){this.#k=e}priority(){return this.#k||this.#g||null}setSignedExchangeInfo(e){this.#T=e}signedExchangeInfo(){return this.#T}setWebBundleInfo(e){this.#R=e}webBundleInfo(){return this.#R}setWebBundleInnerRequestInfo(e){this.#v=e}webBundleInnerRequestInfo(){return this.#v}async populateImageSource(e){const{content:t,encoded:r}=await this.contentData();let s=TextUtils.ContentProvider.contentAsDataURL(t,this.#re,r);if(null===s&&!this.#Z){(this.responseHeaderValue("cache-control")||"").includes("no-cache")||(s=this.#Q)}null!==s&&(e.src=s)}initiator(){return this.#a||null}hasUserGesture(){return this.#i??null}frames(){return this.#P}addProtocolFrameError(e,t){this.addFrame({type:WebSocketFrameType.Error,text:e,time:this.pseudoWallTime(t),opCode:-1,mask:!1})}addProtocolFrame(e,t,r){const s=r?WebSocketFrameType.Send:WebSocketFrameType.Receive;this.addFrame({type:s,text:e.payloadData,time:this.pseudoWallTime(t),opCode:e.opcode,mask:e.mask})}addFrame(e){this.#P.push(e),this.dispatchEventToListeners(Events.WebsocketFrameAdded,e)}eventSourceMessages(){return this.#y}addEventSourceMessage(e,t,r,s){const n={time:this.pseudoWallTime(e),eventName:t,eventId:r,data:s};this.#y.push(n),this.dispatchEventToListeners(Events.EventSourceMessageAdded,n)}markAsRedirect(e){this.#c=!0,this.#e=`${this.#t}:redirected.${e}`}isRedirect(){return this.#c}setRequestIdForTest(e){this.#t=e,this.#e=e}charset(){const e=this.responseHeaderValue("content-type");if(!e)return null;const t=e.replace(/ /g,"").split(";").filter((e=>e.toLowerCase().startsWith("charset="))).map((e=>e.slice(8)));return t.length?t[0]:null}addExtraRequestInfo(e){this.#z=e.blockedRequestCookies,this.#K=e.includedRequestCookies,this.setRequestHeaders(e.requestHeaders),this.#W=!0,this.setRequestHeadersText(""),this.#ie=e.clientSecurityState,this.setConnectTimingFromExtraInfo(e.connectTiming),this.#G=e.siteHasCookieInOtherPartition??!1}hasExtraRequestInfo(){return this.#W}blockedRequestCookies(){return this.#z}includedRequestCookies(){return this.#K}hasRequestCookies(){return this.#K.length>0||this.#z.length>0}siteHasCookieInOtherPartition(){return this.#G}static parseStatusTextFromResponseHeadersText(e){return e.split("\r")[0].split(" ").slice(2).join(" ")}addExtraResponseInfo(e){if(this.#j=e.blockedResponseCookies,this.#$=e.cookiePartitionKey||null,this.#_=e.cookiePartitionKeyOpaque||null,this.responseHeaders=e.responseHeaders,this.originalResponseHeaders=e.responseHeaders.map((e=>({...e}))),e.responseHeadersText){if(this.responseHeadersText=e.responseHeadersText,!this.requestHeadersText()){let e=`${this.requestMethod} ${this.parsedURL.path}`;this.parsedURL.queryParams&&(e+=`?${this.parsedURL.queryParams}`),e+=" HTTP/1.1\r\n";for(const{name:t,value:r}of this.requestHeaders())e+=`${t}: ${r}\r\n`;this.setRequestHeadersText(e)}this.#f=NetworkRequest.parseStatusTextFromResponseHeadersText(e.responseHeadersText)}this.#A=e.resourceIPAddressSpace,e.statusCode&&(this.statusCode=e.statusCode),this.#V=!0;const t=NetworkManager.forRequest(this);if(t)for(const e of this.#j)if(e.blockedReasons.includes("NameValuePairExceedsMaxSize")){const e=i18nString(UIStrings.setcookieHeaderIsIgnoredIn,{PH1:this.url()});t.dispatchEventToListeners(NetworkManagerEvents.MessageGenerated,{message:e,requestId:this.#e,warning:!0})}}hasExtraResponseInfo(){return this.#V}blockedResponseCookies(){return this.#j}responseCookiesPartitionKey(){return this.#$}responseCookiesPartitionKeyOpaque(){return this.#_}redirectSourceSignedExchangeInfoHasNoErrors(){return null!==this.#o&&null!==this.#o.#T&&!this.#o.#T.errors}clientSecurityState(){return this.#ie}setTrustTokenParams(e){this.#oe=e}trustTokenParams(){return this.#oe}setTrustTokenOperationDoneEvent(e){this.#he=e,this.dispatchEventToListeners(Events.TrustTokenResultAdded)}trustTokenOperationDoneEvent(){return this.#he}setIsSameSite(e){this.#xe=e}isSameSite(){return this.#xe}getAssociatedData(e){return this.#we.get(e)||null}setAssociatedData(e,t){this.#we.set(e,t)}deleteAssociatedData(e){this.#we.delete(e)}}export var Events;!function(e){e.FinishedLoading="FinishedLoading",e.TimingChanged="TimingChanged",e.RemoteAddressChanged="RemoteAddressChanged",e.RequestHeadersChanged="RequestHeadersChanged",e.ResponseHeadersChanged="ResponseHeadersChanged",e.WebsocketFrameAdded="WebsocketFrameAdded",e.EventSourceMessageAdded="EventSourceMessageAdded",e.TrustTokenResultAdded="TrustTokenResultAdded"}(Events||(Events={}));export var InitiatorType;!function(e){e.Other="other",e.Parser="parser",e.Redirect="redirect",e.Script="script",e.Preload="preload",e.SignedExchange="signedExchange",e.Preflight="preflight"}(InitiatorType||(InitiatorType={}));export var WebSocketFrameType;!function(e){e.Send="send",e.Receive="receive",e.Error="error"}(WebSocketFrameType||(WebSocketFrameType={}));export const cookieBlockedReasonToUiString=function(e){switch(e){case"SecureOnly":return i18nString(UIStrings.secureOnly);case"NotOnPath":return i18nString(UIStrings.notOnPath);case"DomainMismatch":return i18nString(UIStrings.domainMismatch);case"SameSiteStrict":return i18nString(UIStrings.sameSiteStrict);case"SameSiteLax":return i18nString(UIStrings.sameSiteLax);case"SameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.sameSiteUnspecifiedTreatedAsLax);case"SameSiteNoneInsecure":return i18nString(UIStrings.sameSiteNoneInsecure);case"UserPreferences":return i18nString(UIStrings.userPreferences);case"UnknownError":return i18nString(UIStrings.unknownError);case"SchemefulSameSiteStrict":return i18nString(UIStrings.schemefulSameSiteStrict);case"SchemefulSameSiteLax":return i18nString(UIStrings.schemefulSameSiteLax);case"SchemefulSameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.schemefulSameSiteUnspecifiedTreatedAsLax);case"SamePartyFromCrossPartyContext":return i18nString(UIStrings.samePartyFromCrossPartyContext);case"NameValuePairExceedsMaxSize":return i18nString(UIStrings.nameValuePairExceedsMaxSize)}return""};export const setCookieBlockedReasonToUiString=function(e){switch(e){case"SecureOnly":return i18nString(UIStrings.blockedReasonSecureOnly);case"SameSiteStrict":return i18nString(UIStrings.blockedReasonSameSiteStrictLax,{PH1:"SameSite=Strict"});case"SameSiteLax":return i18nString(UIStrings.blockedReasonSameSiteStrictLax,{PH1:"SameSite=Lax"});case"SameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.blockedReasonSameSiteUnspecifiedTreatedAsLax);case"SameSiteNoneInsecure":return i18nString(UIStrings.blockedReasonSameSiteNoneInsecure);case"UserPreferences":return i18nString(UIStrings.thisSetcookieWasBlockedDueToUser);case"SyntaxError":return i18nString(UIStrings.thisSetcookieHadInvalidSyntax);case"SchemeNotSupported":return i18nString(UIStrings.theSchemeOfThisConnectionIsNot);case"OverwriteSecure":return i18nString(UIStrings.blockedReasonOverwriteSecure);case"InvalidDomain":return i18nString(UIStrings.blockedReasonInvalidDomain);case"InvalidPrefix":return i18nString(UIStrings.blockedReasonInvalidPrefix);case"UnknownError":return i18nString(UIStrings.anUnknownErrorWasEncounteredWhenTrying);case"SchemefulSameSiteStrict":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax,{PH1:"SameSite=Strict"});case"SchemefulSameSiteLax":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesiteStrictLax,{PH1:"SameSite=Lax"});case"SchemefulSameSiteUnspecifiedTreatedAsLax":return i18nString(UIStrings.thisSetcookieDidntSpecifyASamesite);case"SamePartyFromCrossPartyContext":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSameparty);case"SamePartyConflictsWithOtherAttributes":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute);case"NameValuePairExceedsMaxSize":return i18nString(UIStrings.thisSetcookieWasBlockedBecauseTheNameValuePairExceedsMaxSize);case"DisallowedCharacter":return i18nString(UIStrings.thisSetcookieHadADisallowedCharacter)}return""};export const cookieBlockedReasonToAttribute=function(e){switch(e){case"SecureOnly":return Attributes.Secure;case"NotOnPath":return Attributes.Path;case"DomainMismatch":return Attributes.Domain;case"SameSiteStrict":case"SameSiteLax":case"SameSiteUnspecifiedTreatedAsLax":case"SameSiteNoneInsecure":case"SchemefulSameSiteStrict":case"SchemefulSameSiteLax":case"SchemefulSameSiteUnspecifiedTreatedAsLax":return Attributes.SameSite;case"SamePartyFromCrossPartyContext":case"NameValuePairExceedsMaxSize":case"UserPreferences":case"UnknownError":return null}return null};export const setCookieBlockedReasonToAttribute=function(e){switch(e){case"SecureOnly":case"OverwriteSecure":return Attributes.Secure;case"SameSiteStrict":case"SameSiteLax":case"SameSiteUnspecifiedTreatedAsLax":case"SameSiteNoneInsecure":case"SchemefulSameSiteStrict":case"SchemefulSameSiteLax":case"SchemefulSameSiteUnspecifiedTreatedAsLax":return Attributes.SameSite;case"InvalidDomain":return Attributes.Domain;case"InvalidPrefix":return Attributes.Name;case"SamePartyConflictsWithOtherAttributes":case"SamePartyFromCrossPartyContext":case"NameValuePairExceedsMaxSize":case"UserPreferences":case"SyntaxError":case"SchemeNotSupported":case"UnknownError":case"DisallowedCharacter":return null}return null};