import{isNode}from"../environment.js";import{assert}from"../util/assert.js";import{Deferred}from"../util/Deferred.js";import{isErrorLike}from"../util/ErrorLike.js";import{debug}from"./Debug.js";import{CDPElementHandle}from"./ElementHandle.js";import{CDPJSHandle}from"./JSHandle.js";export const debugError=debug("puppeteer:error");export function createEvaluationError(e){let t,r;if(e.exception){if(!("object"===e.exception.type&&"error"===e.exception.subtype||e.exception.objectId))return valueFromRemoteObject(e.exception);{const n=getErrorDetails(e);t=n.name,r=n.message}}else t="Error",r=e.text;const n=r.split("\n").length,o=new Error(r);o.name=t;const i=o.stack.split("\n"),a=i.splice(0,n);if(i.shift(),e.stackTrace&&i.length<Error.stackTraceLimit)for(const t of e.stackTrace.callFrames.reverse()){if(PuppeteerURL.isPuppeteerURL(t.url)&&t.url!==PuppeteerURL.INTERNAL_URL){const e=PuppeteerURL.parse(t.url);i.unshift(`    at ${t.functionName||e.functionName} (${e.functionName} at ${e.siteString}, <anonymous>:${t.lineNumber}:${t.columnNumber})`)}else i.push(`    at ${t.functionName||"<anonymous>"} (${t.url}:${t.lineNumber}:${t.columnNumber})`);if(i.length>=Error.stackTraceLimit)break}return o.stack=[...a,...i].join("\n"),o}export function createClientError(e){let t,r;if(e.exception){if(!("object"===e.exception.type&&"error"===e.exception.subtype||e.exception.objectId))return valueFromRemoteObject(e.exception);{const n=getErrorDetails(e);t=n.name,r=n.message}}else t="Error",r=e.text;const n=r.split("\n").length,o=new Error(r);o.name=t;const i=[],a=o.stack.split("\n").splice(0,n);if(e.stackTrace&&i.length<Error.stackTraceLimit)for(const t of e.stackTrace.callFrames.reverse())if(i.push(`    at ${t.functionName||"<anonymous>"} (${t.url}:${t.lineNumber}:${t.columnNumber})`),i.length>=Error.stackTraceLimit)break;return o.stack=[...a,...i].join("\n"),o}const getErrorDetails=e=>{let t,r="";const n=e.exception?.description?.split("\n    at ")??[],o=Math.min(e.stackTrace?.callFrames.length??0,n.length-1);return n.splice(-o,o),e.exception?.className&&(r=e.exception.className),t=n.join("\n"),r&&t.startsWith(`${r}: `)&&(t=t.slice(r.length+2)),{message:t,name:r}},SOURCE_URL=Symbol("Source URL for Puppeteer evaluation scripts");export class PuppeteerURL{static INTERNAL_URL="pptr:internal";static fromCallSite(e,t){const r=new PuppeteerURL;return r.#e=e,r.#t=t.toString(),r}static parse=e=>{e=e.slice(5);const[t="",r=""]=e.split(";"),n=new PuppeteerURL;return n.#e=t,n.#t=decodeURIComponent(r),n};static isPuppeteerURL=e=>e.startsWith("pptr:");#e;#t;get functionName(){return this.#e}get siteString(){return this.#t}toString(){return`pptr:${[this.#e,encodeURIComponent(this.#t)].join(";")}`}}export const withSourcePuppeteerURLIfNone=(e,t)=>{if(Object.prototype.hasOwnProperty.call(t,SOURCE_URL))return t;const r=Error.prepareStackTrace;Error.prepareStackTrace=(e,t)=>t[2];const n=(new Error).stack;return Error.prepareStackTrace=r,Object.assign(t,{[SOURCE_URL]:PuppeteerURL.fromCallSite(e,n)})};export const getSourcePuppeteerURLIfAvailable=e=>{if(Object.prototype.hasOwnProperty.call(e,SOURCE_URL))return e[SOURCE_URL]};export function valueFromRemoteObject(e){if(assert(!e.objectId,"Cannot extract value when objectId is given"),e.unserializableValue){if("bigint"===e.type)return BigInt(e.unserializableValue.replace("n",""));switch(e.unserializableValue){case"-0":return-0;case"NaN":return NaN;case"Infinity":return 1/0;case"-Infinity":return-1/0;default:throw new Error("Unsupported unserializable value: "+e.unserializableValue)}}return e.value}export async function releaseObject(e,t){t.objectId&&await e.send("Runtime.releaseObject",{objectId:t.objectId}).catch((e=>{debugError(e)}))}export function addEventListener(e,t,r){return e.on(t,r),{emitter:e,eventName:t,handler:r}}export function removeEventListeners(e){for(const t of e)t.emitter.removeListener(t.eventName,t.handler);e.length=0}export const isString=e=>"string"==typeof e||e instanceof String;export const isNumber=e=>"number"==typeof e||e instanceof Number;export const isPlainObject=e=>"object"==typeof e&&e?.constructor===Object;export const isRegExp=e=>"object"==typeof e&&e?.constructor===RegExp;export const isDate=e=>"object"==typeof e&&e?.constructor===Date;export async function waitForEvent(e,t,r,n,o){const i=Deferred.create({message:`Timeout exceeded while waiting for event ${String(t)}`,timeout:n}),a=addEventListener(e,t,(async e=>{await r(e)&&i.resolve(e)}));try{const e=await Deferred.race([i,o]);if(isErrorLike(e))throw e;return e}catch(e){throw e}finally{removeEventListeners([a])}}export function createJSHandle(e,t){return"node"===t.subtype&&e._world?new CDPElementHandle(e,t,e._world.frame()):new CDPJSHandle(e,t)}export function evaluationString(e,...t){if(isString(e))return assert(0===t.length,"Cannot evaluate a string with arguments"),e;return`(${e})(${t.map((function(e){return Object.is(e,void 0)?"undefined":JSON.stringify(e)})).join(",")})`}export function addPageBinding(e,t){const r=globalThis[t];Object.assign(globalThis,{[t](...n){const o=globalThis[t];o.args??=new Map,o.callbacks??=new Map;const i=(o.lastSeq??0)+1;return o.lastSeq=i,o.args.set(i,n),r(JSON.stringify({type:e,name:t,seq:i,args:n,isTrivial:!n.some((e=>e instanceof Node))})),new Promise(((e,t)=>{o.callbacks.set(i,{resolve(t){o.args.delete(i),e(t)},reject(e){o.args.delete(i),t(e)}})}))}})}export function pageBindingInitString(e,t){return evaluationString(addPageBinding,e,t)}export async function waitWithTimeout(e,t,r){const n=Deferred.create({message:`waiting for ${t} failed: timeout ${r}ms exceeded`,timeout:r});return await Deferred.race([e,n])}let fs=null;export async function importFSPromises(){if(!fs)try{fs=await import("fs/promises")}catch(e){if(e instanceof TypeError)throw new Error("Cannot write to a path outside of a Node-like environment.");throw e}return fs}export async function getReadableAsBuffer(e,t){const r=[];if(t){const n=await importFSPromises(),o=await n.open(t,"w+");try{for await(const t of e)r.push(t),await o.writeFile(t)}finally{await o.close()}}else for await(const t of e)r.push(t);try{return Buffer.concat(r)}catch(e){return null}}export async function getReadableFromProtocolStream(e,t){if(!isNode)throw new Error("Cannot create a stream outside of Node.js environment.");const{Readable:r}=await import("stream");let n=!1;return new r({async read(r){if(!n)try{const o=await e.send("IO.read",{handle:t,size:r});this.push(o.data,o.base64Encoded?"base64":void 0),o.eof&&(n=!0,await e.send("IO.close",{handle:t}),this.push(null))}catch(e){if(isErrorLike(e))return void this.destroy(e);throw e}}})}export async function setPageContent(e,t){return e.evaluate((e=>{document.open(),document.write(e),document.close()}),t)}export function getPageContent(){let e="";for(const t of document.childNodes)if(t===document.documentElement)e+=document.documentElement.outerHTML;else e+=(new XMLSerializer).serializeToString(t);return e}export function validateDialogType(e){let t=null;return new Set(["alert","confirm","prompt","beforeunload"]).has(e)&&(t=e),assert(t,`Unknown javascript dialog type: ${e}`),t}