export default{cssContent:"/*\n * Copyright (c) 2014 The Chromium Authors. All rights reserved.\n * Use of this source code is governed by a BSD-style license that can be\n * found in the LICENSE file.\n */\n\n.text-button {\n  margin: 2px;\n  height: 24px;\n  font-size: 12px;\n  border: 1px solid var(--color-background-elevation-2);\n  border-radius: 4px;\n  padding: 0 12px;\n  font-weight: 500;\n  color: var(--legacy-accent-fg-color);\n  background-color: var(--sys-color-cdt-base-container);\n  flex: none;\n  white-space: nowrap;\n}\n\n.text-button:disabled {\n  opacity: 38%;\n}\n\n.text-button:not(:disabled):focus,\n.text-button:not(:disabled):hover,\n.text-button:not(:disabled):active {\n  background-color: var(--color-background-elevation-1);\n  box-shadow: 0 1px 2px var(--divider-line);\n}\n\n.text-button:not(:disabled):active {\n  background-color: var(--color-background-elevation-2);\n}\n\n.text-button:not(:disabled):focus {\n  box-shadow: 0 1px 2px var(--divider-line), 0 0 0 2px var(--color-primary-variant);\n}\n\n.text-button:not(:disabled):not(.running):focus,\n.text-button:not(:disabled):not(.running):hover,\n.text-button:not(:disabled):not(.running):active {\n  color: var(--legacy-accent-fg-color-hover);\n}\n\n.text-button.primary-button {\n  --override-text-button-color: #fff;\n\n  background-color: var(--legacy-accent-color);\n  border: none;\n  color: var(--override-text-button-color);\n}\n\n.text-button.link-style {\n  background: none;\n  border: none;\n  padding: 0 !important; /* stylelint-disable-line declaration-no-important */\n  font: inherit;\n  cursor: pointer;\n  height: 18px;\n}\n\n.text-button.primary-button:not(:disabled):focus,\n.text-button.primary-button:not(:disabled):hover,\n.text-button.primary-button:not(:disabled):active {\n  --override-text-button-color: #fff;\n\n  background-color: var(--legacy-accent-color-hover);\n  color: var(--override-text-button-color);\n}\n\n.-theme-with-dark-background .text-button:not(.primary-button):not(:disabled):focus,\n.-theme-with-dark-background .text-button:not(.primary-button):not(:disabled):hover,\n.-theme-with-dark-background .text-button:not(.primary-button):not(:disabled):active {\n  --override-dark-background-color: #313131;\n  --override-dark-box-shadow-color: rgb(0 0 0 / 10%);\n\n  background-color: var(--override-dark-background-color);\n  box-shadow: 0 1px 2px var(--override-dark-box-shadow-color);\n}\n\n.-theme-with-dark-background .text-button:not(.primary-button):not(:disabled):focus {\n  box-shadow: 0 1px 2px var(--override-dark-box-shadow-color), 0 0 0 2px var(--color-primary-variant);\n}\n\n.-theme-with-dark-background .text-button:not(.primary-button):not(:disabled):active {\n  --override-dark-mode-active-background-color: #3e3e3e;\n\n  background-color: var(--override-dark-mode-active-background-color);\n}\n\n@media (forced-colors: active) {\n  .text-button {\n    background-color: ButtonFace;\n    color: ButtonText;\n    border-color: ButtonText;\n  }\n\n  .text-button:disabled {\n    forced-color-adjust: none;\n    opacity: 100%;\n    background: ButtonFace;\n    border-color: GrayText;\n    color: GrayText;\n  }\n\n  .text-button:not(:disabled):focus {\n    forced-color-adjust: none;\n    background-color: ButtonFace;\n    color: Highlight !important; /* stylelint-disable-line declaration-no-important */\n    border-color: Highlight;\n    outline: 2px solid ButtonText;\n    box-shadow: var(--legacy-focus-ring-active-shadow);\n  }\n\n  .text-button:not(:disabled):hover,\n  .text-button:not(:disabled):active {\n    forced-color-adjust: none;\n    background-color: Highlight;\n    color: HighlightText !important; /* stylelint-disable-line declaration-no-important */\n    box-shadow: var(--legacy-accent-color);\n  }\n\n  .text-button.primary-button {\n    forced-color-adjust: none;\n    background-color: Highlight;\n    color: HighlightText;\n    border: 1px solid Highlight;\n  }\n\n  .text-button.primary-button:not(:disabled):focus {\n    background-color: Highlight;\n    color: HighlightText !important; /* stylelint-disable-line declaration-no-important */\n    border-color: ButtonText;\n  }\n\n  .text-button.primary-button:not(:disabled):hover,\n  .text-button.primary-button:not(:disabled):active {\n    background-color: HighlightText;\n    color: Highlight !important; /* stylelint-disable-line declaration-no-important */\n    border-color: Highlight;\n  }\n}\n"};